# Generated by Django 3.0.5 on 2020-05-02 11:28

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('django_rds_iam_auth', '0036_user_phone_number'),
    ]

    operations = [
        migrations.RunSQL("""
                create function privileged_check_user_role(user_to_check text, role_to_check text) returns boolean
                    security definer
                    language sql
                as
                $$
                SELECT true = ANY (SELECT name LIKE role_to_check FROM (
                    SELECT * FROM api_user_groups ug JOIN auth_group g ON g.id = ug.group_id
                    ) as result
                WHERE user_to_check = user_id);
                $$;
            """, reverse_sql="drop function privileged_check_user_role(text, text);"),
        migrations.RunSQL("""alter function privileged_check_user_role(text, text) owner to postgres;"""),

        migrations.RunSQL("""
            drop policy api_user_table_policy on api_user;
            
            CREATE POLICY api_user_table_policy ON api_user
            USING (
                id = current_user OR
                (
                    privileged_user_has_tenant(current_user, origin_tenant_id) AND
                    (
                        privileged_check_user_role(current_user, 'TenantAdmin%') OR
                        privileged_check_user_role(current_user, 'OrganizationAdmin%')
                    )
                )
            )
            WITH CHECK (
                id = current_user OR
                (
                    privileged_user_has_tenant(current_user, origin_tenant_id) AND
                    (
                        privileged_check_user_role(current_user, 'TenantAdmin%') OR
                        privileged_check_user_role(current_user, 'OrganizationAdmin%')
                    )
                )
            );
            
            """, reverse_sql="drop policy api_user_table_policy on api_user;"),

    ]
